<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>User Guide &mdash; PYKKN 0.1 documentation</title>
      <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="../_static/graphviz.css" type="text/css" />
      <link rel="stylesheet" href="../_static/panels-bootstrap.5fd3999ee7762ccc51105388f4a9d115.css" type="text/css" />
      <link rel="stylesheet" href="../_static/panels-main.c949a650a448cc0ae9fd3441c0e17fb0.css" type="text/css" />
      <link rel="stylesheet" href="../_static/panels-variables.06eb56fa6e07937060861dad626602ad.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="API Reference" href="../reference/index.html" />
    <link rel="prev" title="Getting Started" href="../start/index.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../index.html" class="icon icon-home"> PYKKN
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../start/index.html">Getting Started</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">User Guide</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#example-project-first-steps">Example project first steps</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#setup">Setup</a></li>
<li class="toctree-l3"><a class="reference internal" href="#add-first-data">Add first data</a></li>
<li class="toctree-l3"><a class="reference internal" href="#modelling-a-sensor-characteristic">Modelling a sensor characteristic</a></li>
<li class="toctree-l3"><a class="reference internal" href="#structuring-of-the-data">Structuring of the data</a></li>
<li class="toctree-l3"><a class="reference internal" href="#create-and-store-hdf5-file">Create and store HDF5 file</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#example-project-import-of-a-csv-object">Example project import of a .csv object</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#id1">Setup</a></li>
<li class="toctree-l3"><a class="reference internal" href="#inserting-and-storing-of-the-data">Inserting and storing of the data</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#example-project-import-of-a-json-or-hdf5-file-and-converting-it-to-pykkn">Example project import of a json or HDF5 file and converting it to PYKKN</a></li>
<li class="toctree-l2"><a class="reference internal" href="#recurring-functionalities-and-attributes">Recurring functionalities and attributes</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#set-storage-path-path-str">set_storage_path(path: str)</a></li>
<li class="toctree-l3"><a class="reference internal" href="#store">store()</a></li>
<li class="toctree-l3"><a class="reference internal" href="#show">show()</a></li>
<li class="toctree-l3"><a class="reference internal" href="#add-attrs-dict-dict">add_attrs_dict(Dict)</a></li>
<li class="toctree-l3"><a class="reference internal" href="#name-attribute">name attribute</a></li>
<li class="toctree-l3"><a class="reference internal" href="#attrs-attribute">attrs attribute</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#dataset-modules">Dataset modules</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#dataset-module">Dataset module</a></li>
<li class="toctree-l3"><a class="reference internal" href="#dataset-image">Dataset image</a></li>
<li class="toctree-l3"><a class="reference internal" href="#dataset-video">Dataset video</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../reference/index.html">API reference</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">PYKKN</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
      <li>User Guide</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/user/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="user-guide">
<h1>User Guide<a class="headerlink" href="#user-guide" title="Permalink to this headline"></a></h1>
<section id="example-project-first-steps">
<h2>Example project first steps<a class="headerlink" href="#example-project-first-steps" title="Permalink to this headline"></a></h2>
<section id="setup">
<h3>Setup<a class="headerlink" href="#setup" title="Permalink to this headline"></a></h3>
<p>Let’s start with a short example of how to use Pykraken (PYKKN).
First, you need to implement the following lines of code. This is mandatory for every PYKKN project you are dealing with:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pykkn.dataset</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="kn">from</span> <span class="nn">pykkn.dataset_image</span> <span class="kn">import</span> <span class="n">Dataset_Image</span>
<span class="kn">from</span> <span class="nn">pykkn.dataset_video</span> <span class="kn">import</span> <span class="n">Dataset_Video</span>
<span class="kn">from</span> <span class="nn">pykkn.instrument</span> <span class="kn">import</span> <span class="n">Instrument</span>
<span class="kn">from</span> <span class="nn">pykkn.model</span> <span class="kn">import</span> <span class="n">Model</span>
<span class="kn">from</span> <span class="nn">pykkn.parameter</span> <span class="kn">import</span> <span class="n">Parameter</span>
<span class="kn">from</span> <span class="nn">pykkn.pipeline</span> <span class="kn">import</span> <span class="n">Pipeline</span>
<span class="kn">from</span> <span class="nn">pykkn.run</span> <span class="kn">import</span> <span class="n">Run</span>
</pre></div>
</div>
<p>In this case, we also import Numpy as a widely used library in Python:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
</pre></div>
</div>
</section>
<section id="add-first-data">
<h3>Add first data<a class="headerlink" href="#add-first-data" title="Permalink to this headline"></a></h3>
<p>Now, we can add the first data to our HDF5 file. <br>
We start with a dataset. Below, you can see how to implement it. <br>
In the first line, we create the dataset1 which is called “msmt01”.
This is done by using the constructor (add link to description) of the dataset class. <br>
After that, we add the actual data. For this purpose, create a random set of numbers and then add them to the data paramter of dataset1. <br>
With the third line, we add an attribute to the dataset. Here, we specify the samplerate we used while recording the data.
The name of the parameter is determined in the brackets and the value is added with the equal sign. <br>
In the last line, another attribute is added. In this case, the attribute is a timestamp to document when the data was collected:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s1">&#39;msmt01&#39;</span><span class="p">)</span>
<span class="n">dataset1</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">rand</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">10</span> <span class="o">**</span> <span class="mi">4</span><span class="p">)</span>
<span class="n">dataset1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;samplerate&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1000</span>
<span class="n">dataset1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;timestamp&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;2017-05-14 18:44:11&#39;</span>
</pre></div>
</div>
</section>
<section id="modelling-a-sensor-characteristic">
<h3>Modelling a sensor characteristic<a class="headerlink" href="#modelling-a-sensor-characteristic" title="Permalink to this headline"></a></h3>
<p>Let’s assume the data we collected was measured with a preasure sensor. The sensor creates a voltage signal as an output.
The voltage signal needs to be converted to a pressure value according to a characteristic curve.
To this end, we will implement the characteristic curve as a parameter, add this parameter to a model and create an instrument from this model.
Step by step: let’s start with the parameter. <br>
In the following lines of code, we see how to implement the parameter object.
First, we create the object parameter1 and name it “gain” by writing so in the brackets. <br>
Afterwards, we add some attributes to this parameter:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">parameter1</span> <span class="o">=</span> <span class="n">Parameter</span><span class="p">(</span><span class="s1">&#39;gain&#39;</span><span class="p">)</span>
<span class="n">parameter1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;value&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1</span>
<span class="n">parameter1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;units&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;-&#39;</span>
<span class="n">parameter1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;variable&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;-&#39;</span>
<span class="n">parameter1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;origin&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;this&#39;</span>
</pre></div>
</div>
<p>A more efficient way to add the paramters can be achieved by using the function build_multi_paramters.
First, you need to include the function as follows:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pykkn.build_multi_parameters</span> <span class="kn">import</span> <span class="n">build_multi_parameters</span>
</pre></div>
</div>
<p>Then you can create a dictionary with all the parameters:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dic</span> <span class="o">=</span> <span class="p">{</span>
<span class="s2">&quot;list_of_parameters&quot;</span><span class="p">:</span> <span class="p">[</span>
    <span class="p">{</span><span class="s2">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;gain&quot;</span><span class="p">,</span> <span class="s2">&quot;value&quot;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;units&quot;</span><span class="p">:</span> <span class="s1">&#39;-&#39;</span><span class="p">,</span> <span class="s2">&quot;variables&quot;</span><span class="p">:</span> <span class="s1">&#39;-&#39;</span><span class="p">,</span> <span class="s2">&quot;orign&quot;</span><span class="p">:</span> <span class="s1">&#39;this&#39;</span><span class="p">}</span>
<span class="p">]</span>
<span class="p">}</span>
</pre></div>
</div>
<p>This dictionary can be adding more parameters by just adding another line in curly brackets. <br>
The builrd_multi_parameters uses the before created dictionary:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">paramter1</span> <span class="o">=</span> <span class="n">build_multi_paramters</span><span class="p">(</span><span class="n">dic</span><span class="p">)</span>
</pre></div>
</div>
<p>You can choose one of the two shown ways to create parameters.</p>
<p>The next step is to create model to which we can add the parameters.
In this case, we create the model1 which is called “feedthrough”.
Afterwards we add the parameters to this model:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">model1</span> <span class="o">=</span> <span class="n">Model</span><span class="p">(</span><span class="s1">&#39;feedthrough&#39;</span><span class="p">)</span>
<span class="n">model1</span><span class="o">.</span><span class="n">add</span><span class="p">([</span><span class="n">parameter1</span><span class="p">])</span>
</pre></div>
</div>
<p>Now we can create an instrument. Here we create the instrument1 and name it “transmitter”.
After creating this instrument, we add the model1 to this instrument:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">instrument1</span> <span class="o">=</span> <span class="n">Instrument</span><span class="p">(</span><span class="s1">&#39;transmitter&#39;</span><span class="p">)</span>
<span class="n">instrument1</span><span class="o">.</span><span class="n">add</span><span class="p">([</span><span class="n">model1</span><span class="p">])</span>
</pre></div>
</div>
</section>
<section id="structuring-of-the-data">
<h3>Structuring of the data<a class="headerlink" href="#structuring-of-the-data" title="Permalink to this headline"></a></h3>
<p>In the next step, we add our dataset to a pipeline object. Normally we add several datasets here to generate an array. <br>
At the same time, we store the metadata of the instruments used in a test rig in the pipeline module. <br>
The main purpose of the pipeline class is to struchture and organize the data. <br>
In the lines below, the object pipeline1 is created. In brackets, you can determine
the location where it is stored in the HDF5 file. Afterwards, we add the dataset1 to the pipeline1.
The last three lines contain metadata of the used instrument:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">pipeline1</span> <span class="o">=</span> <span class="n">Pipeline</span><span class="p">(</span><span class="s1">&#39;measured/capa1/raw&#39;</span><span class="p">)</span>
<span class="n">pipeline1</span><span class="o">.</span><span class="n">add</span><span class="p">([</span><span class="n">dataset1</span><span class="p">])</span>
<span class="n">pipeline1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;variable&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;voltage&#39;</span>
<span class="n">pipeline1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;units&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;volts&#39;</span>
<span class="n">pipeline1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;origin&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;this&#39;</span>
</pre></div>
</div>
<p>Now we create an object from the run module to further structure our data.
With the run object, we will add the pipelines and the parameters to each other.
This shown in the lines below. First, we create the object named “run1”.
Then we add some metatadata for our test series:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">msmtrun</span> <span class="o">=</span> <span class="n">Run</span><span class="p">(</span><span class="s1">&#39;run1&#39;</span><span class="p">)</span>
<span class="n">msmtrun</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;author&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;derGeraet&#39;</span>
<span class="n">msmtrun</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;pmanager&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;tcorneli&#39;</span>
<span class="n">msmtrun</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;targettmp&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">double</span><span class="p">(</span><span class="mi">70</span><span class="p">)</span>
<span class="n">msmtrun</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;targetrps&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">double</span><span class="p">(</span><span class="mi">2</span><span class="p">)</span>
<span class="n">msmtrun</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;oil&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;PA06&#39;</span>
</pre></div>
</div>
<p>Now, we can add the pipeline object and the parameter object to the run object:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">msmtrun</span><span class="o">.</span><span class="n">add</span><span class="p">([</span><span class="n">pipeline1</span><span class="p">])</span>

<span class="n">msmtrun</span><span class="o">.</span><span class="n">add</span><span class="p">([</span><span class="n">parameter1</span><span class="p">])</span>
</pre></div>
</div>
</section>
<section id="create-and-store-hdf5-file">
<h3>Create and store HDF5 file<a class="headerlink" href="#create-and-store-hdf5-file" title="Permalink to this headline"></a></h3>
<p>Before we can export our HDF5 file, we need to specify the location where it should be saved and the name of the file.
Pay attention that you use the slash symbol “/” instead of backslash “\” to determine the location
and pay attention that you choose a name for your file plus the ending “.h5”:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">msmtrun</span><span class="o">.</span><span class="n">set_storage_path</span><span class="p">(</span><span class="s2">&quot;C:/Users/Example/PYKKN/example_for_docs.h5&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>The last step is to export the HDF5 file by using the store function with the run object.
This is how we can ensure to export the whole file:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">msmtrun</span><span class="o">.</span><span class="n">store</span><span class="p">()</span>
</pre></div>
</div>
<p>Now, let’s have a look at the created HDF5 file. Below, you can see a picture of the created file.
The structure is fully expanded and an open-source HDF5 viewer is used to show it.
On the left side, you can see the structe of the file we created:</p>
<img alt="../_images/example-project_overviewWholeProject.PNG" src="../_images/example-project_overviewWholeProject.PNG" />
</section>
</section>
<section id="example-project-import-of-a-csv-object">
<h2>Example project import of a .csv object<a class="headerlink" href="#example-project-import-of-a-csv-object" title="Permalink to this headline"></a></h2>
<p>In the following project, we will show you how to store data from a csv table in an HDF5 file using PYKKN. <br>
This might be usefull if, for example, your data is stored in an Excel sheet. With Excel, you can then export the file as a csv file and store it into HDF5.
As an example, look at the following table:</p>
<table class="docutils align-default" id="id2">
<caption><span class="caption-text">Example Table</span><a class="headerlink" href="#id2" title="Permalink to this table"></a></caption>
<colgroup>
<col style="width: 25%" />
<col style="width: 25%" />
<col style="width: 25%" />
<col style="width: 25%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>time [s]</p></th>
<th class="head"><p>sensor 1</p></th>
<th class="head"><p>sensor 2</p></th>
<th class="head"><p>sensor 3</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>0.01</p></td>
<td><p>6.040</p></td>
<td><p>4.350</p></td>
<td><p>1.694</p></td>
</tr>
<tr class="row-odd"><td><p>0.05</p></td>
<td><p>0.903</p></td>
<td><p>2.261</p></td>
<td><p>1.930</p></td>
</tr>
<tr class="row-even"><td><p>0.10</p></td>
<td><p>7.621</p></td>
<td><p>0.922</p></td>
<td><p>0.023</p></td>
</tr>
<tr class="row-odd"><td><p>0.15</p></td>
<td><p>1.922</p></td>
<td><p>4.974</p></td>
<td><p>0.317</p></td>
</tr>
<tr class="row-even"><td><p>0.20</p></td>
<td><p>8.510</p></td>
<td><p>0.796</p></td>
<td><p>0.545</p></td>
</tr>
<tr class="row-odd"><td><p>0.25</p></td>
<td><p>4.515</p></td>
<td><p>4.384</p></td>
<td><p>1.640</p></td>
</tr>
<tr class="row-even"><td><p>0.30</p></td>
<td><p>4.163</p></td>
<td><p>1.112</p></td>
<td><p>1.828</p></td>
</tr>
<tr class="row-odd"><td><p>0.35</p></td>
<td><p>6.909</p></td>
<td><p>4.202</p></td>
<td><p>1.622</p></td>
</tr>
<tr class="row-even"><td><p>0.40</p></td>
<td><p>1.679</p></td>
<td><p>0.713</p></td>
<td><p>0.381</p></td>
</tr>
<tr class="row-odd"><td><p>0.45</p></td>
<td><p>2.809</p></td>
<td><p>0.068</p></td>
<td><p>0.612</p></td>
</tr>
<tr class="row-even"><td><p>0.50</p></td>
<td><p>5.402</p></td>
<td><p>3.884</p></td>
<td><p>1.152</p></td>
</tr>
<tr class="row-odd"><td><p>0.55</p></td>
<td><p>4.481</p></td>
<td><p>0.834</p></td>
<td><p>1.898</p></td>
</tr>
<tr class="row-even"><td><p>0.60</p></td>
<td><p>1.429</p></td>
<td><p>0.854</p></td>
<td><p>0.176</p></td>
</tr>
<tr class="row-odd"><td><p>0.65</p></td>
<td><p>7.038</p></td>
<td><p>4.113</p></td>
<td><p>1.584</p></td>
</tr>
<tr class="row-even"><td><p>0.70</p></td>
<td><p>2.110</p></td>
<td><p>4.087</p></td>
<td><p>0.262</p></td>
</tr>
<tr class="row-odd"><td><p>0.75</p></td>
<td><p>0.920</p></td>
<td><p>0.167</p></td>
<td><p>0.442</p></td>
</tr>
<tr class="row-even"><td><p>0.80</p></td>
<td><p>4.918</p></td>
<td><p>2.122</p></td>
<td><p>0.476</p></td>
</tr>
<tr class="row-odd"><td><p>0.85</p></td>
<td><p>8.989</p></td>
<td><p>3.269</p></td>
<td><p>1.093</p></td>
</tr>
<tr class="row-even"><td><p>0.90</p></td>
<td><p>0.883</p></td>
<td><p>4.461</p></td>
<td><p>1.848</p></td>
</tr>
<tr class="row-odd"><td><p>0.95</p></td>
<td><p>2.475</p></td>
<td><p>0.164</p></td>
<td><p>0.422</p></td>
</tr>
<tr class="row-even"><td><p>1.00</p></td>
<td><p>1.653</p></td>
<td><p>3.396</p></td>
<td><p>0.550</p></td>
</tr>
</tbody>
</table>
<section id="id1">
<h3>Setup<a class="headerlink" href="#id1" title="Permalink to this headline"></a></h3>
<p>Let’s start by setting up the project as usual, though in this short case we would not need all the extensions:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">pykkn.dataset</span> <span class="kn">import</span> <span class="n">Dataset</span>
</pre></div>
</div>
<p>In this case, it is important to add the panda framework as well because we will use this to store the CSV file:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">panda</span> <span class="k">as</span> <span class="nn">pd</span>
</pre></div>
</div>
</section>
<section id="inserting-and-storing-of-the-data">
<h3>Inserting and storing of the data<a class="headerlink" href="#inserting-and-storing-of-the-data" title="Permalink to this headline"></a></h3>
<p>At first, we will store the CSV file as a variable which we can then add to dataset object. To do this, we use the function read_csv() from the panda framework.
In the parameters of the function you put the name of the csv file. In this case the table is stored in the same folder as the example project.
That is why no further import path is needed. The second paramter in this case is called “sep=;”. Is specifies how the data in the csv table are seperated:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="s2">&quot;exampleTable.csv&quot;</span><span class="p">,</span> <span class="n">sep</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>Afterwards, we create a dataset object and add the df variable to this object:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;from_csv_table&quot;</span><span class="p">)</span>
<span class="n">dataset1</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">values</span>
</pre></div>
</div>
<p>Before storing the hdf5 file set the storage path. In this case only a name is given:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">set_storage_path</span><span class="p">(</span><span class="s2">&quot;from_csv_table.h5&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>To create the HDF5 file from this, we use the store() function:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">store</span><span class="p">()</span>
</pre></div>
</div>
<p>The output of this short project can be seen below. By double-clicking on the “from_csv_table” object on the left you can open the window shwon in the left with stored data:</p>
<img alt="../_images/csv_file_hdf5.jpg" src="../_images/csv_file_hdf5.jpg" />
</section>
</section>
<section id="example-project-import-of-a-json-or-hdf5-file-and-converting-it-to-pykkn">
<h2>Example project import of a json or HDF5 file and converting it to PYKKN<a class="headerlink" href="#example-project-import-of-a-json-or-hdf5-file-and-converting-it-to-pykkn" title="Permalink to this headline"></a></h2>
<p>PYKKN is a tool to collect data and store them in a hierarchically structure. One can store the collected data in a HDF5 or json file.
Let’s assume you already have a project stored in a HDF5 oder json file format. On the existing file you want to work on using PYKKKN.
To do so it is mandatory to have the data structured in the way PYKKN does.
One way to achieve this would be to create the whole file again from scratch using PYKKN. To avoid this there are functions to convert an existing HDF5 or json file into the PYKKN structure. <br>
In the following graphic this structure is shown again. One can see that the store() function is used to create a HDF5 or json file.
Now, the pykkn_pars functions are used to import an existing HDF5 or json file and convert it into the PYKKN structure:</p>
<a class="reference external image-reference" href="../_images/PYKKN_structure.svg"><img alt="../_images/Slide1.SVG" src="../_images/Slide1.SVG" /></a>
<p>Let’s have a look how to use this functions in a short example project: <br></p>
<p>First, the necessary functions need to be imported. For the case that you want to convert an existing HDF% file import the following one:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pykkn.parse</span> <span class="kn">import</span> <span class="n">pykkn_parse</span>
</pre></div>
</div>
<p>If you have an existing json file use the following line of code:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">pykkn.parse_json</span> <span class="kn">import</span> <span class="n">pykkn_parse</span>
</pre></div>
</div>
<p>For this example the HDF5 file that was created in the first example project is used. How to add the data to the project is not shown here again.
To use the import function you use the code below:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">result_msmtrun</span> <span class="o">=</span> <span class="n">pykkn_parse</span><span class="p">(</span><span class="s2">&quot;example_for_docs.h5&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>In this case the name of the HDF5 file was “example_project_docs.h5”. <br></p>
<p>For the json case the code looks as follows:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">result_msmtrun</span> <span class="o">=</span> <span class="n">pykkn_parse</span><span class="p">(</span><span class="s2">&quot;example_for_docs.json&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>As one can see it is similar to the line before instead of the file format in the end. In both case you now need to use the store function to create the HDF5 or json file. <br>
HDF5 format:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">result_msmtrun</span><span class="o">.</span><span class="n">store</span><span class="p">()</span>
</pre></div>
</div>
<p>json format:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">result_msmtrun</span><span class="o">.</span><span class="n">store</span><span class="p">(</span><span class="n">json</span><span class="p">)</span>
</pre></div>
</div>
<p>In this case the storage path is not further specified so the file will be created where the script is located. Use the set_storage_path() function to change this.</p>
</section>
<section id="recurring-functionalities-and-attributes">
<h2>Recurring functionalities and attributes<a class="headerlink" href="#recurring-functionalities-and-attributes" title="Permalink to this headline"></a></h2>
<p>In PYKKN, you will find several functions that are avalaible in different modules. To achieve this, the library is based on object-oriented programming
and several modules inherit functions from the storable class. The functions of this class will be explained below in more detail to avoid explaining again for each module.
For further information about the storable class, you can visit the API reference. (add link to API refrence) <br></p>
<p>To give you a brief overview of the classtructure of PYKKN you can have a look at the UML diagram below (feel free to click on the graphic to zoom in):</p>
<a class="reference external image-reference" href="../_images/20-09-07_PYKKN_UMLdiagram_clearBackground.svg"><img alt="../_images/20-09-07_PYKKN_UMLdiagram_clearBackground.svg" src="../_images/20-09-07_PYKKN_UMLdiagram_clearBackground.svg" /></a>
<p>The following modules inherit from the storage class (add links to the api reference):</p>
<ul class="simple">
<li><p>dataset</p></li>
<li><p>dataset_image</p></li>
<li><p>dataset_keyvalue</p></li>
<li><p>dataset_video</p></li>
<li><p>instrument</p></li>
<li><p>model</p></li>
<li><p>parameter</p></li>
<li><p>pipeline</p></li>
<li><p>run</p></li>
</ul>
<p>All the objects that are created from these classes can use the following functions:</p>
<section id="set-storage-path-path-str">
<h3>set_storage_path(path: str)<a class="headerlink" href="#set-storage-path-path-str" title="Permalink to this headline"></a></h3>
<p>Every object that is created from theses classes can export HDF5 files.
Before doing so, the storage path needs to be defined. Therefore, you add the storage path
to the function as a parameter. The storage path needs to be in quotation marks (“”) and end on the name
of the HDF5 file plus the ending “.h5”. Here, you can see an example:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">set_storage_path</span><span class="p">(</span><span class="s2">&quot;C:/Users/Example/data1.h5&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>Be aware to use the slash symbol “/” instead of backslash “\”.</p>
</section>
<section id="store">
<h3>store()<a class="headerlink" href="#store" title="Permalink to this headline"></a></h3>
<p>To create the HDF5 file from any object, use the store function. An example is shown below:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">store</span><span class="p">()</span>
</pre></div>
</div>
</section>
<section id="show">
<h3>show()<a class="headerlink" href="#show" title="Permalink to this headline"></a></h3>
<p>This function will show you the content of an object, for example the attributes:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</section>
<section id="add-attrs-dict-dict">
<h3>add_attrs_dict(Dict)<a class="headerlink" href="#add-attrs-dict-dict" title="Permalink to this headline"></a></h3>
<p>With this function, you can add a flat dictionary of key values to an object as a set of attributes.
The key represents the name of the attribute and the value represents the value assigned to the attribute:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">add_attrs_dict</span><span class="p">(</span><span class="n">myDictionary</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="name-attribute">
<h3>name attribute<a class="headerlink" href="#name-attribute" title="Permalink to this headline"></a></h3>
<p>Next to the functions, an object from the classes named before inherits two different attributes from the storage class:
The first attribute is the name. Normally, this attribute is attached to the object as a parameter when calling the constructor of the object. An example can be seen below:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">preasureData</span>
</pre></div>
</div>
<p>Do not mix up this name of the object. The name of the object in this case is “data1” and mandatory to call the object in Python.
The name preasureData is one that will be shown in the HDF5 file.</p>
</section>
<section id="attrs-attribute">
<h3>attrs attribute<a class="headerlink" href="#attrs-attribute" title="Permalink to this headline"></a></h3>
<p>The attrs attribute represents metadata that can be attached to every object. The type of metadata will be further specified in the different modules below:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">data1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;samplerate&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1000</span>
</pre></div>
</div>
</section>
</section>
<section id="dataset-modules">
<h2>Dataset modules<a class="headerlink" href="#dataset-modules" title="Permalink to this headline"></a></h2>
<p>The main porpose behind PYKKN is to store data in a structured way.
While doing this we do not want to lose any kind of data or metadata.
Therefore, PYKKN provides the opportunity to store several different types of data. In the following lines, the modules to store data will be explained in more detail.</p>
<section id="dataset-module">
<h3>Dataset module<a class="headerlink" href="#dataset-module" title="Permalink to this headline"></a></h3>
<p>With the dataset module, you are able to store an array of numbers.
As PYKKN is made for scientific research, the dataset modle is typically used when
storing measured data from a test rig. Apart from the pure data, it is possible to
store metadata such as the samplerate and the timestamp. <br></p>
<p>To create a dataset object, the constructor is needed.
The parameter of the constructor determines the name of the dataset.
This is also the name shown in the HDF5 file in the end.
You can see an example here:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s1">&#39;nameOfDataset&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>The name of the object in this example is “dataset1”. The name of the object is important
for further coding in Python, for example in the next part. <br></p>
<p>To add data to the dataset object, we access the data array of the object which was created when the object itself was created.
We can overwrite this array with our data:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">measuredData</span>
</pre></div>
</div>
<p>To add the samplerate and the timestamp as metadata, we access the attributes of the dataset1 object.
At this point, it is mandatory to specify which attribute we want to access.
This is done by typing “samplerate” or “timestamp” in the brackets when accessing the attributes.
The samplerate is represented as a number in 1/s. The timestamp should have the form YYYY-MM-DD HH:mm:ss.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;samplerate&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1000</span>
<span class="n">dataset1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;timestamp&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;2022-06-12 10:39:11&#39;</span>
</pre></div>
</div>
<p>If you want to create an HDF5 file from this dataset, it possible to do so.
In PYKKN it is possible to create an HDF5 file from every single object that is created.
Therefore, we first set up the storage path by writing it in the brackets of the set_storage_path() function.
Keep in mind to use the slash symbol “/” in the path instead of backslash “\” and add the name plus “.h5” in the end of the path:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">set_storage_path</span><span class="p">(</span><span class="s1">&#39;test/test_ut_ds.h5&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>Now, to create the HDF5 file we call the store() function:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataset1</span><span class="o">.</span><span class="n">store</span><span class="p">()</span>
</pre></div>
</div>
</section>
<section id="dataset-image">
<h3>Dataset image<a class="headerlink" href="#dataset-image" title="Permalink to this headline"></a></h3>
<p>With this module, the user is enabled to store an image in the HDF5 file. If you are dealing with a video, please use dataset_video module
instead of trying to store it as an array of images with this module. There are two steps to implement an image.
First, you create an object of the datasat_image class and give it a name when using the constructor. In this case the name is “image_dataset_1.
Afterwards, you add the path of the image where it is stored so PYKKN can collect the data:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">datasetImage1</span> <span class="o">=</span> <span class="n">Dataset_Image</span><span class="p">(</span><span class="s1">&#39;image_dataset_1&#39;</span><span class="p">)</span>
<span class="n">datasetImage1</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="s2">&quot;/test/test_rig_1.jpg&quot;</span>
</pre></div>
</div>
<p>As further metadata, you can add, for example, the timestamp to the image object:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">dataseImage1</span><span class="p">[</span><span class="s1">&#39;timestemp&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;2022-06-12 10:45:21&#39;</span>
</pre></div>
</div>
<p>This command is comparable to the one of the datasat module.</p>
</section>
<section id="dataset-video">
<h3>Dataset video<a class="headerlink" href="#dataset-video" title="Permalink to this headline"></a></h3>
<p>If you want to store a video in your HDF5 file, you can use this module. The usage is very similar to the image module.
First, create an object that represents the video you want to store. Then, add the storage path. If you want, you can also
add the timestamp as metadata:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">datasetVideo1</span> <span class="o">=</span> <span class="n">Dataset_Video</span><span class="p">(</span><span class="s1">&#39;video_dataset_1&#39;</span><span class="p">)</span>
<span class="n">datasetVideo1</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="s2">&quot;C:/Users/Administrator/Videos/Captures/test_meeting _recording.mp4&quot;</span>
<span class="n">datasetVideo1</span><span class="o">.</span><span class="n">attrs</span><span class="p">[</span><span class="s1">&#39;timestamp&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;2022-06-13 11:22:11&#39;</span>
</pre></div>
</div>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../start/index.html" class="btn btn-neutral float-left" title="Getting Started" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../reference/index.html" class="btn btn-neutral float-right" title="API Reference" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2022, ADP Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>